/**
 * ENXP.java
 *
 * File generated from the medication::ENXP uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication;

// End of user code
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class ENXP.
 *
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ENXP", propOrder = {
	"partType",
	"qualifier"
})
@XmlRootElement(name = "ENXP")
public class ENXP extends net.ihe.gazelle.medication.ST1 implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	/**
	 *                       Indicates whether the name part is a
	                            given name, family                      name, prefix, suffix, etc.
	                        .
	 */
	@XmlAttribute(name = "partType")
	public net.ihe.gazelle.medication.EntityNamePartType partType;
	/**
	 *                       The qualifier is a set of codes each
	                            of which specifies                      a certain subcategory of the
	                            name part in addition to                      the main name part type.
	                            For example, a given name may                      be flagged as a
	                            nickname, a family name may be a                      pseudonym or a
	                            name of public records.                   .
	 */
	@XmlAttribute(name = "qualifier")
	public java.lang.String qualifier;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return partType.
	 * @return partType :                       Indicates whether the name part is a
	                            given name, family                      name, prefix, suffix, etc.
	                                              Indicates whether the name part is a
	                            given name, family                      name, prefix, suffix, etc.
	                                              Indicates whether the name part is a
	                            given name, family                      name, prefix, suffix, etc.
	                                              Indicates whether the name part is a
	                            given name, family                      name, prefix, suffix, etc.
	                                              Indicates whether the name part is a
	                            given name, family                      name, prefix, suffix, etc.
	                                              Indicates whether the name part is a
	                            given name, family                      name, prefix, suffix, etc.
	                                              Indicates whether the name part is a
	                            given name, family                      name, prefix, suffix, etc.
	                        
	 */
	public net.ihe.gazelle.medication.EntityNamePartType getPartType() {
	    return partType;
	}
	
	/**
	 * Set a value to attribute partType.
	 * @param partType :                       Indicates whether the name part is a
	                            given name, family                      name, prefix, suffix, etc.
	                                              Indicates whether the name part is a
	                            given name, family                      name, prefix, suffix, etc.
	                                              Indicates whether the name part is a
	                            given name, family                      name, prefix, suffix, etc.
	                                              Indicates whether the name part is a
	                            given name, family                      name, prefix, suffix, etc.
	                                              Indicates whether the name part is a
	                            given name, family                      name, prefix, suffix, etc.
	                                              Indicates whether the name part is a
	                            given name, family                      name, prefix, suffix, etc.
	                                              Indicates whether the name part is a
	                            given name, family                      name, prefix, suffix, etc.
	                        .
	 */
	public void setPartType(net.ihe.gazelle.medication.EntityNamePartType partType) {
	    this.partType = partType;
	}
	
	
	
	
	/**
	 * Return qualifier.
	 * @return qualifier :                       The qualifier is a set of codes each
	                            of which specifies                      a certain subcategory of the
	                            name part in addition to                      the main name part type.
	                            For example, a given name may                      be flagged as a
	                            nickname, a family name may be a                      pseudonym or a
	                            name of public records.                                         The qualifier is a set of codes each
	                            of which specifies                      a certain subcategory of the
	                            name part in addition to                      the main name part type.
	                            For example, a given name may                      be flagged as a
	                            nickname, a family name may be a                      pseudonym or a
	                            name of public records.                                         The qualifier is a set of codes each
	                            of which specifies                      a certain subcategory of the
	                            name part in addition to                      the main name part type.
	                            For example, a given name may                      be flagged as a
	                            nickname, a family name may be a                      pseudonym or a
	                            name of public records.                                         The qualifier is a set of codes each
	                            of which specifies                      a certain subcategory of the
	                            name part in addition to                      the main name part type.
	                            For example, a given name may                      be flagged as a
	                            nickname, a family name may be a                      pseudonym or a
	                            name of public records.                                         The qualifier is a set of codes each
	                            of which specifies                      a certain subcategory of the
	                            name part in addition to                      the main name part type.
	                            For example, a given name may                      be flagged as a
	                            nickname, a family name may be a                      pseudonym or a
	                            name of public records.                                         The qualifier is a set of codes each
	                            of which specifies                      a certain subcategory of the
	                            name part in addition to                      the main name part type.
	                            For example, a given name may                      be flagged as a
	                            nickname, a family name may be a                      pseudonym or a
	                            name of public records.                                         The qualifier is a set of codes each
	                            of which specifies                      a certain subcategory of the
	                            name part in addition to                      the main name part type.
	                            For example, a given name may                      be flagged as a
	                            nickname, a family name may be a                      pseudonym or a
	                            name of public records.                   
	 */
	public java.lang.String getQualifier() {
	    return qualifier;
	}
	
	/**
	 * Set a value to attribute qualifier.
	 * @param qualifier :                       The qualifier is a set of codes each
	                            of which specifies                      a certain subcategory of the
	                            name part in addition to                      the main name part type.
	                            For example, a given name may                      be flagged as a
	                            nickname, a family name may be a                      pseudonym or a
	                            name of public records.                                         The qualifier is a set of codes each
	                            of which specifies                      a certain subcategory of the
	                            name part in addition to                      the main name part type.
	                            For example, a given name may                      be flagged as a
	                            nickname, a family name may be a                      pseudonym or a
	                            name of public records.                                         The qualifier is a set of codes each
	                            of which specifies                      a certain subcategory of the
	                            name part in addition to                      the main name part type.
	                            For example, a given name may                      be flagged as a
	                            nickname, a family name may be a                      pseudonym or a
	                            name of public records.                                         The qualifier is a set of codes each
	                            of which specifies                      a certain subcategory of the
	                            name part in addition to                      the main name part type.
	                            For example, a given name may                      be flagged as a
	                            nickname, a family name may be a                      pseudonym or a
	                            name of public records.                                         The qualifier is a set of codes each
	                            of which specifies                      a certain subcategory of the
	                            name part in addition to                      the main name part type.
	                            For example, a given name may                      be flagged as a
	                            nickname, a family name may be a                      pseudonym or a
	                            name of public records.                                         The qualifier is a set of codes each
	                            of which specifies                      a certain subcategory of the
	                            name part in addition to                      the main name part type.
	                            For example, a given name may                      be flagged as a
	                            nickname, a family name may be a                      pseudonym or a
	                            name of public records.                                         The qualifier is a set of codes each
	                            of which specifies                      a certain subcategory of the
	                            name part in addition to                      the main name part type.
	                            For example, a given name may                      be flagged as a
	                            nickname, a family name may be a                      pseudonym or a
	                            name of public records.                   .
	 */
	public void setQualifier(java.lang.String qualifier) {
	    this.qualifier = qualifier;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "ENXP").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(ENXP eNXP, String location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (eNXP != null){
   			net.ihe.gazelle.medication.ST1.validateByModule(eNXP, location, cvm, diagnostic);
    	}
    }

}